var sqlite3 = require('sqlite3');
var open = require('sqlite').open;

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let relation = await db.run('INSERT INTO problem_relation (parent_id, child_id) VALUES (@parent_id, @child_id)',
            { '@parent_id': entity.parent_id, '@child_id': entity.child_id });

        await db.close();
        return { id: relation.lastID };
    },
    update: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let relation = await db.run('UPDATE problem_relation SET parent_id = @parent_id, child_id = @child_id WHERE id = @id',
        { '@parent_id': entity.parent_id, '@child_id': entity.child_id, '@id': entity.id });

        await db.close();
        return { id: relation.lastID };
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('DELETE FROM problem_relation WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM problem_relation WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM problem_relation');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem_relation WHERE id = @id', { '@id': id });
        let relation = await stmt.get();
        await stmt.finalize();

        await db.close()
        return relation;
    },
    getAll: async () => {
        // Returns all entities from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem_relation');
        let relations = await stmt.all();
        await stmt.finalize();

        await db.close()
        return relations;
    }
}

module.exports = repository;